<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Project_Task_Response_DataType StructType
 * Meta information extracted from the WSDL
 * - documentation: Project Task Response Data
 * @subpackage Structs
 */
class Project_Task_Response_DataType extends AbstractStructBase
{
    /**
     * The Project_Task
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\Project_TaskType[]
     */
    public $Project_Task;
    /**
     * Constructor method for Project_Task_Response_DataType
     * @uses Project_Task_Response_DataType::setProject_Task()
     * @param \StructType\Project_TaskType[] $project_Task
     */
    public function __construct(array $project_Task = array())
    {
        $this
            ->setProject_Task($project_Task);
    }
    /**
     * Get Project_Task value
     * @return \StructType\Project_TaskType[]|null
     */
    public function getProject_Task()
    {
        return $this->Project_Task;
    }
    /**
     * This method is responsible for validating the values passed to the setProject_Task method
     * This method is willingly generated in order to preserve the one-line inline validation within the setProject_Task method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateProject_TaskForArrayConstraintsFromSetProject_Task(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $project_Task_Response_DataTypeProject_TaskItem) {
            // validation for constraint: itemType
            if (!$project_Task_Response_DataTypeProject_TaskItem instanceof \StructType\Project_TaskType) {
                $invalidValues[] = is_object($project_Task_Response_DataTypeProject_TaskItem) ? get_class($project_Task_Response_DataTypeProject_TaskItem) : sprintf('%s(%s)', gettype($project_Task_Response_DataTypeProject_TaskItem), var_export($project_Task_Response_DataTypeProject_TaskItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Project_Task property can only contain items of type \StructType\Project_TaskType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Project_Task value
     * @throws \InvalidArgumentException
     * @param \StructType\Project_TaskType[] $project_Task
     * @return \StructType\Project_Task_Response_DataType
     */
    public function setProject_Task(array $project_Task = array())
    {
        // validation for constraint: array
        if ('' !== ($project_TaskArrayErrorMessage = self::validateProject_TaskForArrayConstraintsFromSetProject_Task($project_Task))) {
            throw new \InvalidArgumentException($project_TaskArrayErrorMessage, __LINE__);
        }
        $this->Project_Task = $project_Task;
        return $this;
    }
    /**
     * Add item to Project_Task value
     * @throws \InvalidArgumentException
     * @param \StructType\Project_TaskType $item
     * @return \StructType\Project_Task_Response_DataType
     */
    public function addToProject_Task(\StructType\Project_TaskType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Project_TaskType) {
            throw new \InvalidArgumentException(sprintf('The Project_Task property can only contain items of type \StructType\Project_TaskType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Project_Task[] = $item;
        return $this;
    }
}
